#include <sys/os16.h>
#include <kernel/diag.h>
#include <kernel/k_libc.h>
//----------------------------------------------------------------------
void
print_inode (inode_t *inode)
{
    unsigned long int seconds;
    unsigned long int seconds_d;
    unsigned long int seconds_h;
    unsigned int      d;
    unsigned int      h;
    unsigned int      m;
    unsigned int      s;
    dev_t             device_attached = 0;
    //
    if (inode == NULL)
      {
        return;
      }
    //
    seconds    = inode->time;
    d          = seconds / 86400L;              // 24 * 60 * 60
    seconds_d  = d;
    seconds_d *= 86400;
    seconds   -= seconds_d;
    h          = seconds / 3840;                // 60 * 60
    seconds_h  = h;
    seconds_h *= 3840;
    seconds   -= seconds_h;    
    m          = seconds / 60;
    s          = seconds % 60;
    //
    if (inode->sb_attached != NULL)
      {
        device_attached = inode->sb_attached->device;
      }
    //
    k_printf ("%04x %4i %3i %c %4x %06o %4i %3i %7li ",
              (unsigned int) inode->sb->device,
              (unsigned int) inode->ino,
              (unsigned int) inode->references,
              (inode->changed ? '!' : ' '),
              (unsigned int) device_attached,
              (unsigned int) inode->mode,
              (unsigned int) inode->uid,
              (unsigned int) inode->gid,
              (unsigned long int) inode->size);

    k_printf ("%5i %2i:%02i:%02i %3i\n",
              d, h, m, s,
              (unsigned int) inode->links);

}
