#include <sys/os16.h>
#include <kernel/diag.h>
#include <kernel/k_libc.h>
//----------------------------------------------------------------------
void
print_memory_map (void)
{
    uint16_t    *mem_block[MEM_BLOCK_SIZE/2];
    uint16_t     block_rank;
    unsigned int b;
    unsigned int m;
    unsigned int i;
    addr_t       start;

    start = 0;
    dev_io ((pid_t) -1, DEV_MEM, DEV_READ, start, mem_block,
            MEM_BLOCK_SIZE, NULL);

    for (m = 0; m < MEM_MAX_BLOCKS; m++)
      {
        i = m % 16;
        if (i == 0)
          {
            block_rank = 0;
          }
        //
        for (b = 0; b < (MEM_BLOCK_SIZE / 2); b++)
          {
            if (mem_block[b])
              {
                block_rank |= (0x8000 >> i);
                break;
              }
          }
        //
        if (i == 15)
          {
            k_printf ("%04x", block_rank);
          }
        //
        start += MEM_BLOCK_SIZE;
        dev_io ((pid_t) -1, DEV_MEM, DEV_READ, start, mem_block,
                MEM_BLOCK_SIZE, NULL);
      }
}
