#include <sys/os16.h>
#include <kernel/diag.h>
#include <kernel/k_libc.h>
//----------------------------------------------------------------------
void
print_proc_pid (proc_t *ps, pid_t pid)
{
    char  stat;
    switch (ps->status)
      {
        case PROC_EMPTY   : stat = '-'; break;
        case PROC_CREATED : stat = 'c'; break;
        case PROC_READY   : stat = 'r'; break;
        case PROC_RUNNING : stat = 'R'; break;
        case PROC_SLEEPING: stat = 's'; break;
        case PROC_ZOMBIE  : stat = 'z'; break;
        default           : stat = '?'; break;
      }

    k_printf ("%2i %2i %2i %04x %4i %4i %4i %02i.%02i %c %05lx %04x ",
              (unsigned int) ps->ppid,
              (unsigned int) pid,
              (unsigned int) ps->pgrp,
              (unsigned int) ps->device_tty,
              (unsigned int) ps->uid,
              (unsigned int) ps->euid,
              (unsigned int) ps->suid,
              (unsigned int) ((ps->usage / CLOCKS_PER_SEC) / 60),
              (unsigned int) ((ps->usage / CLOCKS_PER_SEC) % 60),
              stat,
              (unsigned long int) ps->address_i,
              (unsigned int) ps->size_i);

    k_printf ("%05lx %04x %04x %s",
              (unsigned long int) ps->address_d,
              (unsigned int) ps->size_d,
              (unsigned int) ps->sp,
                             ps->name);

    k_printf ("\n");
}
