#include <kernel/fs.h>
#include <errno.h>
#include <kernel/k_libc.h>
//----------------------------------------------------------------------
int
inode_free (inode_t *inode)
{
    int      map_element;
    int      map_bit;
    int      map_mask;
    //
    if (inode == NULL)
      {
        errset (EINVAL);        // Invalid argument.
        return (-1);
      }
    //
    map_element = inode->ino / 16;
    map_bit     = inode->ino % 16;
    map_mask    = 1 << map_bit;
    //
    if (inode->sb->map_inode[map_element] & map_mask)
      {
        inode->sb->map_inode[map_element] -= map_mask;
        inode->sb->changed = 1;
      }
    //
    inode->mode       = 0;
    inode->uid        = 0;
    inode->gid        = 0;
    inode->size       = 0;
    inode->time       = 0;
    inode->links      = 0;
    inode->changed    = 1;
    inode->references = 0;
    //
    return (inode_save (inode));
}
