#include <kernel/ibm_i86.h>
#include <kernel/k_libc.h>
#include <sys/os16.h>
#include <sys/types.h>
#include <stdint.h>
//----------------------------------------------------------------------
size_t
dsk_write_bytes (int drive, off_t offset, void *buffer, size_t count)
{
    unsigned char *data_buffer = (unsigned char *) buffer;
    int            status;
    unsigned int   sector;
    unsigned char  sector_buffer[DSK_SECTOR_SIZE];
    int            i;
    int            j = 0;
    size_t         k = 0;
    size_t         m = 0;

    sector = offset / DSK_SECTOR_SIZE;
    i      = offset % DSK_SECTOR_SIZE;
    status = dsk_read_sectors (drive, sector, sector_buffer, 1);

    if (status != 0)
      {
        return ((size_t) 0);
      }

    while (count)
      {
        m = k;
        for (; i < DSK_SECTOR_SIZE && count > 0;
               i++, j++, k++, count--, offset++)
          {
            sector_buffer[i] = data_buffer[j];
          }
        status = dsk_write_sectors (drive, sector, sector_buffer, 1);
        if (status != 0)
          {
            return (m);
          }
        if (count)
          {
            sector = offset / DSK_SECTOR_SIZE;
            i      = offset % DSK_SECTOR_SIZE;
            status = dsk_read_sectors (drive, sector, sector_buffer, 1);
            if (status != 0)
              {
                return (m);
              }
          }
      }
    return (k);
}


