#include <kernel/proc.h>
#include <kernel/k_libc.h>
#include <kernel/diag.h>
//----------------------------------------------------------------------
pid_t
proc_find (segment_t segment_d)
{
    int    pid;
    addr_t address_d;
    for (pid = 0; pid < PROCESS_MAX; pid++)
      {
        if (proc_table[pid].segment_d == segment_d)
          {
            break;
          }
      }
    if (pid >= PROCESS_MAX)
      {
        address_d  = segment_d;
        address_d *= 16;
        k_printf ("\n"
                  "Kernel panic: cannot find the interrupted process "
                  "inside the process table. "
                  "The wanted process has data segment 0x%04x \n"
                  "(effective address %05lx)!\n",
                  (unsigned int) segment_d, address_d);
        print_proc_list ();
        print_segments ();
        k_printf (" ");
        print_kmem ();
        k_printf (" ");
        print_time ();
        k_printf ("\n");
        print_mb_map ();
        k_printf ("\n");
        k_exit (0);
      }
    return (pid);
}
