#include <kernel/proc.h>
//----------------------------------------------------------------------
void
proc_sig_core (pid_t pid, int sig)
{
    addr_t address_i;
    addr_t address_d;
    size_t size_i;
    size_t size_d;
    //
    if (proc_sig_status (pid, sig))
      {
        if (proc_sig_ignore (pid, sig))
          {
            proc_sig_off (pid, sig);
          }
        else
          {
            //
            // Save process addresses and sizes (might be useful if
            // we want to try to exit the process before core dump.
            //
            address_i   = proc_table[pid].address_i;
            address_d   = proc_table[pid].address_d;
            size_i      = proc_table[pid].size_i;
            size_d      = proc_table[pid].size_d;
            //
            // Core dump: the process who formally writes the file
            // is the terminating one.
            //
            if (address_d == address_i)
              {
                proc_dump_memory (pid, address_i, size_i, "core");
              }
            else
              {
                proc_dump_memory (pid, address_i, size_i, "core.i");
                proc_dump_memory (pid, address_d, size_d, "core.d");
              }
            //
            // The signal, translated to negative, is returned (but
            // the effective value received by the application will
            // be cutted, leaving only the low 8 bit).
            //
            proc_sys_exit (pid, -sig);
          }
      }
}
