#include <kernel/proc.h>
#include <errno.h>
//----------------------------------------------------------------------
sighandler_t
proc_sys_signal (pid_t pid, int sig, sighandler_t handler)
{
    unsigned long int flag = 1L << (sig - 1);
    sighandler_t      previous;

    if (sig <= 0)
      {
        errset (EINVAL);
        return (SIG_ERR);
      }

    if (proc_table[pid].sig_ignore & flag)
      {
        previous = SIG_IGN;
      }
    else
      {
        previous = SIG_DFL;
      }

    if (handler == SIG_DFL)
      {
        proc_table[pid].sig_ignore ^= flag;
        return (previous);
      }
    else if (handler == SIG_IGN)
      {
        proc_table[pid].sig_ignore |= flag;
        return (previous);
      }
    else
      {
        errset (EINVAL);
        return (SIG_ERR);
      }
}
