#include <kernel/tty.h>
//----------------------------------------------------------------------
tty_t *
tty_reference (dev_t device)
{
    int t;              // Terminal index.
    //
    // If device is zero, a reference to the whole table is returned.
    //
    if (device == 0)
      {
        return (tty_table);
      }
    //
    // Otherwise, a scan is made to find the selected device.
    //
    for (t = 0; t < TTYS_TOTAL; t++)
      {
        if (tty_table[t].device == device)
          {
            //
            // Device found. Return the pointer.
            //
            return (&tty_table[t]);
          }
      }
    //
    // No device found!
    //
    return (NULL);
}
