#include <string.h>
#include <errno.h>
//----------------------------------------------------------------------
#define ERROR_MAX 100
//----------------------------------------------------------------------
char *
strerror (int errnum)
{
    static char *err[ERROR_MAX];
    //
    err[0] 				= "No error";
    err[E2BIG] 				= TEXT_E2BIG;
    err[EACCES] 			= TEXT_EACCES;
    err[EADDRINUSE]			= TEXT_EADDRINUSE;
    err[EADDRNOTAVAIL]			= TEXT_EADDRNOTAVAIL;
    err[EAFNOSUPPORT]			= TEXT_EAFNOSUPPORT;
    err[EAGAIN]				= TEXT_EAGAIN;
    err[EALREADY]			= TEXT_EALREADY;
    err[EBADF]				= TEXT_EBADF;
    err[EBADMSG]			= TEXT_EBADMSG;
    err[EBUSY]				= TEXT_EBUSY;
    err[ECANCELED]			= TEXT_ECANCELED;
    err[ECHILD]				= TEXT_ECHILD;
    err[ECONNABORTED]			= TEXT_ECONNABORTED;
    err[ECONNREFUSED]			= TEXT_ECONNREFUSED;
    err[ECONNRESET]			= TEXT_ECONNRESET;
    err[EDEADLK]			= TEXT_EDEADLK;
    err[EDESTADDRREQ]			= TEXT_EDESTADDRREQ;
    err[EDOM]				= TEXT_EDOM;
    err[EDQUOT]				= TEXT_EDQUOT;
    err[EEXIST]				= TEXT_EEXIST;
    err[EFAULT]				= TEXT_EFAULT;
    err[EFBIG]				= TEXT_EFBIG;
    err[EHOSTUNREACH]			= TEXT_EHOSTUNREACH;
    err[EIDRM]				= TEXT_EIDRM;
    err[EILSEQ]				= TEXT_EILSEQ;
    err[EINPROGRESS]			= TEXT_EINPROGRESS;
    err[EINTR]				= TEXT_EINTR;
    err[EINVAL]				= TEXT_EINVAL;
    err[EIO]				= TEXT_EIO;
    err[EISCONN]			= TEXT_EISCONN;
    err[EISDIR]				= TEXT_EISDIR;
    err[ELOOP]				= TEXT_ELOOP;
    err[EMFILE]				= TEXT_EMFILE;
    err[EMLINK]				= TEXT_EMLINK;
    err[EMSGSIZE]			= TEXT_EMSGSIZE;
    err[EMULTIHOP]			= TEXT_EMULTIHOP;
    err[ENAMETOOLONG]			= TEXT_ENAMETOOLONG;
    err[ENETDOWN]			= TEXT_ENETDOWN;
    err[ENETRESET]			= TEXT_ENETRESET;
    err[ENETUNREACH]			= TEXT_ENETUNREACH;
    err[ENFILE]				= TEXT_ENFILE;
    err[ENOBUFS]			= TEXT_ENOBUFS;
    err[ENODATA]			= TEXT_ENODATA;
    err[ENODEV]				= TEXT_ENODEV;
    err[ENOENT]				= TEXT_ENOENT;
    err[ENOEXEC]			= TEXT_ENOEXEC;
    err[ENOLCK]				= TEXT_ENOLCK;
    err[ENOLINK]			= TEXT_ENOLINK;
    err[ENOMEM]				= TEXT_ENOMEM;
    err[ENOMSG]				= TEXT_ENOMSG;
    err[ENOPROTOOPT]			= TEXT_ENOPROTOOPT;
    err[ENOSPC]				= TEXT_ENOSPC;
    err[ENOSR]				= TEXT_ENOSR;
    err[ENOSTR]				= TEXT_ENOSTR;
    err[ENOSYS]				= TEXT_ENOSYS;
    err[ENOTCONN]			= TEXT_ENOTCONN;
    err[ENOTDIR]			= TEXT_ENOTDIR;
    err[ENOTEMPTY]			= TEXT_ENOTEMPTY;
    err[ENOTSOCK]			= TEXT_ENOTSOCK;
    err[ENOTSUP]			= TEXT_ENOTSUP;
    err[ENOTTY]				= TEXT_ENOTTY;
    err[ENXIO]				= TEXT_ENXIO;
    err[EOPNOTSUPP]			= TEXT_EOPNOTSUPP;
    err[EOVERFLOW]			= TEXT_EOVERFLOW;
    err[EPERM]				= TEXT_EPERM;
    err[EPIPE]				= TEXT_EPIPE;
    err[EPROTO]				= TEXT_EPROTO;
    err[EPROTONOSUPPORT]		= TEXT_EPROTONOSUPPORT;
    err[EPROTOTYPE]			= TEXT_EPROTOTYPE;
    err[ERANGE]				= TEXT_ERANGE;
    err[EROFS]				= TEXT_EROFS;
    err[ESPIPE]				= TEXT_ESPIPE;
    err[ESRCH]				= TEXT_ESRCH;
    err[ESTALE]				= TEXT_ESTALE;
    err[ETIME]				= TEXT_ETIME;
    err[ETIMEDOUT]			= TEXT_ETIMEDOUT;
    err[ETXTBSY]			= TEXT_ETXTBSY;
    err[EWOULDBLOCK]			= TEXT_EWOULDBLOCK;
    err[EXDEV]				= TEXT_EXDEV;
    err[E_FILE_TYPE]			= TEXT_E_FILE_TYPE;
    err[E_ROOT_INODE_NOT_CACHED]	= TEXT_E_ROOT_INODE_NOT_CACHED;
    err[E_CANNOT_READ_SUPERBLOCK]	= TEXT_E_CANNOT_READ_SUPERBLOCK;
    err[E_MAP_INODE_TOO_BIG]		= TEXT_E_MAP_INODE_TOO_BIG;
    err[E_MAP_ZONE_TOO_BIG]		= TEXT_E_MAP_ZONE_TOO_BIG;
    err[E_DATA_ZONE_TOO_BIG]		= TEXT_E_DATA_ZONE_TOO_BIG;
    err[E_CANNOT_FIND_ROOT_DEVICE]	= TEXT_E_CANNOT_FIND_ROOT_DEVICE;
    err[E_CANNOT_FIND_ROOT_INODE]	= TEXT_E_CANNOT_FIND_ROOT_INODE;
    err[E_FILE_TYPE_UNSUPPORTED]	= TEXT_E_FILE_TYPE_UNSUPPORTED;
    err[E_ENV_TOO_BIG]			= TEXT_E_ENV_TOO_BIG;
    err[E_LIMIT]			= TEXT_E_LIMIT;
    err[E_NOT_MOUNTED]			= TEXT_E_NOT_MOUNTED;
    err[E_NOT_IMPLEMENTED]		= TEXT_E_NOT_IMPLEMENTED;
    //
    if (errnum >= ERROR_MAX || errnum < 0)
      {
        return ("Unknown error");
      }
    //
    return (err[errnum]);
}
