#include <sys/os16.h>
#include <string.h>
#include <stdio.h>
//----------------------------------------------------------------------
void
input_line (char *line, char *prompt, size_t size, int type)
{
    int   i;    // Index inside the `line[]' array.
    int   c;    // Character received from keyboard.

    if (prompt != NULL || strlen (prompt) > 0)
      {
        printf ("%s ", prompt);
      }
    //
    // Loop for character input. Please note that the loop
    // will exit only through `break', where the input line
    // will also be correctly terminated with '\0'.
    //
    for (i = 0;; i++)
      {
        c = getchar ();
        //
        // Control codes.
        //
        if (c == EOF)
          {
            line[i] = 0;
            break;
          }
        else if (c == 4)        // [Ctrl D]
          {
            line[i] = 0;
            break;
          }
        else if (c == 10)       // [Enter]
          {
            line[i] = 0;
            break;
          }
        else if (c == 8)        // [Backspace]
          {
            if (i == 0)
              {
                //
                // It is already the lowest position, so the video
                // cursor is moved forward again, so that the prompt
                // is not overwritten.
                // The index is set to -1, so that on the next loop,
                // it will be again zero.
                //
                printf (" ");
                i = -1;
              }
            else
              {
                i -= 2;
              }
            continue;
          }
        //
        // If `i' is equal `size - 1', it is not allowed to continue
        // typing.
        //
        if (i == (size - 1))
          {
            //
            // Ignore typing, move back the cursor, delete the character
            // typed and move back again.
            //
            printf ("\b \b");
            i--;
            continue;
          }
        //
        // Typing is allowed.
        //
        line[i] = c;
        //
        // Verify if it should be hidden.
        //
        if (type == INPUT_LINE_HIDDEN)
          {
            printf ("\b ");     // Space: at least you see something.
          }
        else if (type == INPUT_LINE_STARS)
          {
            printf ("\b*");
          }
      }
}
