#include <unistd.h>
#include <sys/types.h>
#include <sys/os16.h>
#include <errno.h>
#include <string.h>
#include <string.h>
//----------------------------------------------------------------------
int
execve (const char *path, char *const argv[], char *const envp[])
{
    sysmsg_exec_t msg;
    size_t         size;
    size_t         arg_size;
    int            argc;
    size_t         env_size;
    int            envc;
    char          *arg_data = msg.arg_data;
    char          *env_data = msg.env_data;
    //
    msg.ret   = 0;
    msg.errno = 0;
    //
    strncpy (msg.path, path, PATH_MAX);
    //
    // Copy `argv[]' inside a the message buffer `msg.arg_data',
    // separating each string with a null character and counting the
    // number of strings inside `argc'.
    //
    for (argc = 0, arg_size = 0, size = 0;
	 argv       != NULL         &&
         argc        < (ARG_MAX/16) &&
         arg_size    < ARG_MAX/2    &&
         argv[argc] != NULL;
         argc++, arg_size += size)
      {
	size = strlen (argv[argc]);
	size++;		// Count also the final null character.
	if (size > (ARG_MAX/2 - arg_size))
	  {
	    errset (E2BIG);	// Argument list too long.
	    return (-1);
	  }
	strncpy (arg_data, argv[argc], size);
	arg_data += size;
      }
    msg.argc = argc;
    //
    // Copy `envp[]' inside a the message buffer `msg.env_data',
    // separating each string with a null character and counting the
    // number of strings inside `envc'.
    //
    for (envc = 0, env_size = 0, size = 0;
	 envp       != NULL         &&
         envc        < (ARG_MAX/16) &&
         env_size    < ARG_MAX/2    &&
         envp[envc] != NULL;
         envc++, env_size += size)
      {
	size = strlen (envp[envc]);
	size++;		// Count also the final null character.
	if (size > (ARG_MAX/2 - env_size))
	  {
	    errset (E2BIG); 	// Argument list too long.
	    return (-1);
	  }
	strncpy (env_data, envp[envc], size);
	env_data += size;
      }
    msg.envc = envc;
    //
    // System call.
    //
    sys (SYS_EXEC, &msg, (sizeof msg));
    //
    // Should not return, but if it does, then there is an error.
    //
    errno = msg.errno;
    errln = msg.errln;
    strncpy (errfn, msg.errfn, PATH_MAX);
    return (msg.ret);
}
