#include <sys/stat.h>
#include <sys/os16.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
//----------------------------------------------------------------------
int
isatty (int fdn)
{
    struct stat file_status;
    //
    // Verify to have valid input data.
    //
    if (fdn < 0)
      {
        errset (EBADF);
        return (0);
      }
    //
    // Verify the standard input.
    //
    if (fstat(fdn, &file_status) == 0)
      {
        if (major (file_status.st_rdev) == DEV_CONSOLE_MAJOR)
          {
    	    return (1); // Meaning it is ok!
          }
        if (major (file_status.st_rdev) == DEV_TTY_MAJOR)
          {
    	    return (1); // Meaning it is ok!
          }
      }
    else
      {
	errset (errno);
        return (0);
      }
    //
    // If here, it is not a terminal of any kind.
    //
    errset (EINVAL);
    return (0);
}
